<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform" 
    xmlns:xmi="http://schema.omg.org/spec/XMI/2.1" 
    xmlns:uml="http://schema.omg.org/spec/UML/2.2" 
    xmlns:set="http://exslt.org/sets">
<xsl:output method="xml" indent="yes" omit-xml-declaration="yes"/>
<xsl:strip-space elements="*"/>

<xsl:template match="/">
	<xsl:comment>Created with HeKaTe Translator (ARDML(tph) - XMIv2.1) v1.6 alpha </xsl:comment>
    <!-- XMI header for XMI ver. 2.1 and UML ver. 2.2 -->
	<xsl:element name="xmi:XMI">
	    <xsl:attribute name="xmi:version">2.1</xsl:attribute>
	    <xsl:element name="xmi:Documentation">
	       <xsl:attribute name="contact">hekate.ia.agh.edu.pl</xsl:attribute>
	       <xsl:attribute name="exporter">HeKatE Translator (ARDML - XMIv2.1)</xsl:attribute>
	    </xsl:element>
	       <xsl:element name="uml:Package">
	           <xsl:attribute name="name">hml</xsl:attribute>
	           <xsl:attribute name="xmi:id">hml</xsl:attribute>
	           <xsl:element name="packagedElement">
	               <xsl:attribute name="name">ard</xsl:attribute>
	               <xsl:attribute name="xmi:id">ard</xsl:attribute>
	               <xsl:attribute name="xmi:type">uml:Package</xsl:attribute>
	               <xsl:attribute name="visibility">public</xsl:attribute>
	           	   <xsl:apply-templates select="//hml/properties" mode="properties"/>
	               <xsl:apply-templates select="//hml/tph" mode="tph"/>	
	               <xsl:apply-templates select="//hml/ard" mode="ard"/>                  	   
	           </xsl:element>             	          	      
	       </xsl:element>
	</xsl:element>
</xsl:template>

 <!-- ARD & TPH model - properties as classes -->
	<xsl:template match="properties/property[@id = /hml/tph/hist/@src | /hml/tph/hist/@dst | /hml/ard/dep/@independent | /hml/ard/dep/@dependent]" mode="properties">               
        <xsl:choose>
            <!-- complex properties with more than one attribute -->
            <xsl:when test="count(attref) > 1">
            	<xsl:element name="packagedElement">
            		<xsl:attribute name="xmi:type">uml:Class</xsl:attribute>
            		<xsl:attribute name="visibility">public</xsl:attribute>
            		<xsl:attribute name="isAbstract">true</xsl:attribute>
            		<xsl:attribute name="name"><xsl:text>Group_</xsl:text><xsl:apply-templates select="@id"/></xsl:attribute>
            		<xsl:attribute name="xmi:id"><xsl:text>class_</xsl:text><xsl:apply-templates select="@id"/></xsl:attribute>	    
            		<xsl:for-each select="attref">
            			<xsl:element name="ownedAttribute">
            				<xsl:attribute name="xmi:type">uml:Property</xsl:attribute>
            				<xsl:attribute name="visibility">public</xsl:attribute>
            				<xsl:attribute name="isAbstract">true</xsl:attribute>
            				<xsl:attribute name="name">
            					<xsl:variable name="att_id"><xsl:value-of select="@ref"/></xsl:variable>
            					<xsl:for-each select= "/hml/attributes/attr[@id = $att_id]"><xsl:value-of select="@name"/></xsl:for-each>
            				</xsl:attribute>
            				<xsl:attribute name="xmi:id"><xsl:text>property_</xsl:text><xsl:value-of select="generate-id(.)"/></xsl:attribute>
            			</xsl:element>
            		</xsl:for-each>
            	</xsl:element>
            </xsl:when>
            <xsl:otherwise>
            <!-- simple properties with one attribute -->
            	<xsl:element name="packagedElement">
            		<xsl:attribute name="xmi:type">uml:Class</xsl:attribute>
            		<xsl:attribute name="visibility">public</xsl:attribute>
            		<xsl:attribute name="isAbstract">false</xsl:attribute>
            		<xsl:attribute name="name">
            			<xsl:for-each select="attref">
            				<xsl:variable name="att_ref"><xsl:value-of select="@ref"/></xsl:variable>
            				<xsl:for-each select="//hml/attributes/attr">
            					<xsl:if test="@id=$att_ref"><xsl:value-of select="@name"/></xsl:if>
            				</xsl:for-each>
            			</xsl:for-each>
            		</xsl:attribute>
            		<xsl:attribute name="xmi:id"><xsl:text>class_</xsl:text><xsl:apply-templates select="@id"/></xsl:attribute>	
            	</xsl:element>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
        
    <!-- Dependency between properties -->
    <xsl:template match="hist" mode="tph">
        <xsl:variable name="prop">
            <xsl:value-of select="@dst"/>
        </xsl:variable>
        <xsl:variable name="id">
            <xsl:value-of select="concat(@src,@dst)"/>
        </xsl:variable>

        <xsl:choose>
            <!-- Dependency between properties - refine -->
            <xsl:when test="count(//hml/properties/property[@id = $prop]/attref)>1">
            	<xsl:element name="packagedElement">
            		<xsl:attribute name="xmi:type">uml:Dependency</xsl:attribute>
            		<xsl:attribute name="visibility">public</xsl:attribute>
            		<xsl:attribute name="xmi:id"><xsl:text>depR_</xsl:text><xsl:value-of select="$id"/></xsl:attribute>
            		<xsl:attribute name="name">refine</xsl:attribute>
            		<xsl:element name="supplier">
            			<xsl:attribute name="xmi:idref"><xsl:text>class_</xsl:text><xsl:value-of select="@src"/></xsl:attribute>
            		</xsl:element>
            		<xsl:element name="client">
            			<xsl:attribute name="xmi:idref"><xsl:text>class_</xsl:text><xsl:value-of select="@dst"/></xsl:attribute>         
			</xsl:element>
            	</xsl:element>
            </xsl:when>
            <xsl:otherwise>
            <!-- Dependency between properties - association -->
                <xsl:variable name="startId"><xsl:value-of select="@src"/></xsl:variable>
                <xsl:variable name="endId"><xsl:value-of select="@dst"/></xsl:variable>
            	<xsl:element name="packagedElement">
            		<xsl:attribute name="xmi:type">uml:Association</xsl:attribute>
            		<xsl:attribute name="visibility">public</xsl:attribute>
            		<xsl:attribute name="xmi:id"><xsl:text>asoc_</xsl:text><xsl:value-of select="$id"/></xsl:attribute>
            		<xsl:element name="ownedEnd">            			
            			<xsl:attribute name="xmi:id"><xsl:text>ownEnd_</xsl:text><xsl:value-of select="$id"/><xsl:value-of select="@src"/></xsl:attribute>
            			<xsl:attribute name="xmi:type">uml:Property</xsl:attribute>	
            			<xsl:attribute name="type"><xsl:text>class_</xsl:text><xsl:value-of select="@src"/></xsl:attribute>
            			<xsl:element name="association">        
            				<xsl:attribute name="xmi:idref"><xsl:text>asoc_</xsl:text><xsl:value-of select="$id"/></xsl:attribute>
            			</xsl:element>
            		</xsl:element>
            		<xsl:element name="ownedEnd">            			
            			<xsl:attribute name="xmi:id"><xsl:text>ownEnd_</xsl:text><xsl:value-of select="$id"/><xsl:value-of select="@dst"/></xsl:attribute>
            			<xsl:attribute name="xmi:type">uml:Property</xsl:attribute>	
            			<xsl:attribute name="type"><xsl:text>class_</xsl:text><xsl:value-of select="@dst"/></xsl:attribute>
            			<xsl:attribute name="aggregation">shared</xsl:attribute>
            			<xsl:element name="association">        
            				<xsl:attribute name="xmi:idref"><xsl:text>asoc_</xsl:text><xsl:value-of select="$id"/></xsl:attribute>
            			</xsl:element>
            		</xsl:element>
            		<xsl:element name="memberEnd">            			
            			<xsl:attribute name="xmi:idref"><xsl:text>ownEnd_</xsl:text><xsl:value-of select="$id"/><xsl:value-of select="@src"/></xsl:attribute>
            		</xsl:element>
            		<xsl:element name="memberEnd">            			
            			<xsl:attribute name="xmi:idref"><xsl:text>ownEnd_</xsl:text><xsl:value-of select="$id"/><xsl:value-of select="@dst"/></xsl:attribute>
            		</xsl:element>
            	</xsl:element>            	
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>


    <!-- Dependency between properties in ARD mode -->
    <xsl:template match="dep" mode="ard">
        <xsl:element name="packagedElement">
            <xsl:attribute name="xmi:type">uml:Dependency</xsl:attribute>            
            <xsl:attribute name="name">derive</xsl:attribute>
            <xsl:attribute name="xmi:id"><xsl:text>dep_</xsl:text><xsl:value-of select="@independent"/><xsl:value-of select="@dependent"/></xsl:attribute>	
            <xsl:element name="supplier">
                <xsl:attribute name="xmi:idref"><xsl:text>class_</xsl:text><xsl:value-of select="@independent"/></xsl:attribute>                        
            </xsl:element>
            <xsl:element name="client">
                <xsl:attribute name="xmi:idref"><xsl:text>class_</xsl:text><xsl:value-of select="@dependent"/></xsl:attribute>                        
            </xsl:element>
        </xsl:element>                    
    </xsl:template>

<xsl:template match="xtt"/>
<xsl:template match="types"/>
</xsl:stylesheet>

