<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1" xmlns:uml="http://schema.omg.org/spec/UML/2.2" xmlns:set="http://exslt.org/sets">
<xsl:output method="xml" doctype-system="hml.dtd" version="1.0" indent="yes" /> 
<xsl:template match="/">
	<xsl:comment>Created with HeKatE Translator (XMIv2.1 to ARDML) v1.4 alpha</xsl:comment> 
	<xsl:element name="hml"><xsl:apply-templates/></xsl:element>
</xsl:template>

<xsl:key name="ref_attr" match=".//packagedElement[@xmi:type = 'uml:Class']/ownedAttribute/@name | .//packagedElement[@xmi:type = 'uml:Class'][count(ownedAttribute[@xmi:type = 'uml:Property'])=0]/@name" use="." />
<xsl:key name="ref_prop" match=".//packagedElement[@xmi:type = 'uml:Class']/@name" use="." />

<xsl:template match="packagedElement">

 <!-- ATTRIBUTES -->
 <xsl:text>&#9;</xsl:text>  <!-- 1x tab -->
 <xsl:element name="attributes"><xsl:text>&#xa;</xsl:text>
  <xsl:for-each select="set:distinct(.//packagedElement[@xmi:type = 'uml:Class']/ownedAttribute/@name | .//packagedElement[@xmi:type = 'uml:Class'][count(ownedAttribute[@xmi:type = 'uml:Property'])=0]/@name)">
	<xsl:text>&#9;&#9;</xsl:text> <!-- 2x tab -->
	<xsl:element name="attr">
	 <xsl:attribute name="name"><xsl:value-of select="."/></xsl:attribute>	
	 <xsl:attribute name="type"><xsl:text>tpe_tmp</xsl:text></xsl:attribute>	
	 <xsl:attribute name="class"><xsl:text>simple</xsl:text></xsl:attribute>	
	 <xsl:attribute name="id"><xsl:text>att_</xsl:text><xsl:value-of select="substring(generate-id(.),3)"/></xsl:attribute>
	</xsl:element>
	<xsl:text>&#xa;</xsl:text> <!-- new line -->
  </xsl:for-each>
  <xsl:text>&#9;</xsl:text> <!-- 1x tab -->
 </xsl:element><!-- end of the attributes element -->

 <!-- PROPERTIES -->
 <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + 1x tab -->
 <xsl:element name="properties"><xsl:text>&#xa;</xsl:text>
  <xsl:for-each select=".//packagedElement[@xmi:type = 'uml:Class']">
	<xsl:variable name="property_name"><xsl:value-of select="@name"/></xsl:variable>
	<xsl:text>&#9;&#9;</xsl:text>  <!-- new line + 2x tab -->
	<xsl:element name="property">
	<xsl:attribute name="id"><xsl:text>prp_</xsl:text><xsl:value-of select="substring(generate-id(@name),3)"/></xsl:attribute>
		<xsl:choose>
			<xsl:when test="count(ownedAttribute[@xmi:type = 'uml:Property']) > 1">
				<xsl:for-each select="ownedAttribute[@xmi:type = 'uml:Property']">
					<xsl:text>&#xa;&#9;&#9;&#9;</xsl:text>  <!-- new line + 3x tab -->
					<xsl:element name="attref">
						<xsl:attribute name="ref">
							<xsl:text>att_</xsl:text><xsl:value-of select="substring(generate-id(key('ref_attr',@name)),3)"/>
						</xsl:attribute>	
					</xsl:element>
				</xsl:for-each>
			</xsl:when>
			<xsl:when test="count(ownedAttribute[@xmi:type = 'uml:Property']) = 0">
				<xsl:text>&#xa;&#9;&#9;&#9;</xsl:text>  <!-- new line + 3x tab -->
				<xsl:element name="attref">
					<xsl:attribute name="ref">
						<xsl:text>att_</xsl:text><xsl:value-of select="substring(generate-id(key('ref_attr',$property_name)),3)"/>
					</xsl:attribute>	
				</xsl:element>
			</xsl:when>
			<xsl:otherwise>
				<!-- this case should not occur -->
				<xsl:text>&#xa;</xsl:text>  <!-- new line -->
				<xsl:comment>error: the class <xsl:value-of select="$property_name"/> has only one attribute!</xsl:comment> 
				<xsl:text>&#xa;</xsl:text>  <!-- new line -->
			</xsl:otherwise>
		</xsl:choose>

	<xsl:text>&#xa;&#9;&#9;</xsl:text> <!-- new line + 2x tab -->
	</xsl:element> <!-- end of the property element -->
  	<xsl:text>&#xa;</xsl:text> <!-- new line -->
  </xsl:for-each>
  <xsl:text>&#9;</xsl:text> <!-- 1x tab -->
 </xsl:element> <!-- end of the properties element -->

 <!-- TPH -->
 <xsl:text>&#xa;&#9;</xsl:text>  <!-- new line + 1x tab -->
 <xsl:element name="tph"><xsl:text>&#xa;</xsl:text>
  <xsl:for-each select=".//packagedElement[@xmi:type = 'uml:Dependency'][@name = 'refine']">
	<xsl:variable name="supplier_name">
	  <xsl:value-of select="..//packagedElement[@xmi:type = 'uml:Class'][@xmi:id = current()/supplier/@xmi:idref]/@name"/>
	</xsl:variable>
	<xsl:variable name="client_name">
	  <xsl:value-of select="..//packagedElement[@xmi:type = 'uml:Class'][@xmi:id = current()/client/@xmi:idref]/@name"/>
	</xsl:variable>

	<xsl:text>&#9;&#9;</xsl:text> <!-- 2x tab -->
	<xsl:element name="hist"> <!-- creates the hist element with id="dep_" src="prp_" dst="prp_"-->
	  <xsl:attribute name="id"><xsl:text>dep_</xsl:text><xsl:value-of select="substring(generate-id(.),3)"/></xsl:attribute>
	  <xsl:attribute name="src">
		<xsl:text>prp_</xsl:text><xsl:value-of select="substring(generate-id(key('ref_prop',$supplier_name)),3)"/>
	  </xsl:attribute>
	  <xsl:attribute name="dst">
		<xsl:text>prp_</xsl:text><xsl:value-of select="substring(generate-id(key('ref_prop',$client_name)),3)"/>
	  </xsl:attribute>
	</xsl:element>
	<xsl:text>&#xa;</xsl:text> <!-- new line -->
  </xsl:for-each>

  <xsl:for-each select=".//packagedElement[@xmi:type = 'uml:Association']">
	<xsl:variable name="aggregation_end">
	  <xsl:value-of select="..//packagedElement[@xmi:type = 'uml:Class'][@xmi:id = current()/ownedEnd[@aggregation = 'shared']/@type]/@name"/>
	</xsl:variable>
	<xsl:variable name="association_end">
	  <xsl:value-of select="..//packagedElement[@xmi:type = 'uml:Class'][@xmi:id = current()/ownedEnd/@type]/@name"/>
	</xsl:variable>

	<xsl:text>&#9;&#9;</xsl:text> <!-- 2x tab -->
	<xsl:element name="hist"> <!-- creates the hist element with id="dep_" src="prp_" dst="prp_"-->
	  <xsl:attribute name="id"><xsl:text>hst_</xsl:text><xsl:value-of select="substring(generate-id(.),3)"/></xsl:attribute>
	  <xsl:attribute name="src">
		<xsl:text>prp_</xsl:text><xsl:value-of select="substring(generate-id(key('ref_prop',$association_end)),3)"/>
	  </xsl:attribute>
	  <xsl:attribute name="dst">
		<xsl:text>prp_</xsl:text><xsl:value-of select="substring(generate-id(key('ref_prop',$aggregation_end)),3)"/>
	  </xsl:attribute>
	</xsl:element>
	<xsl:text>&#xa;</xsl:text> <!-- new line -->

  </xsl:for-each>
  <xsl:text>&#9;</xsl:text> <!-- 1x tab -->
 </xsl:element><!-- end of the tph element -->

 <!-- ARD -->
 <xsl:text>&#xa;&#9;</xsl:text>  <!-- new line + 1x tab -->
 <xsl:element name="ard"><xsl:text>&#xa;</xsl:text>
  <xsl:for-each select=".//packagedElement[@xmi:type = 'uml:Dependency'][@name = 'derive']">
	<xsl:variable name="supplier_name">
	  <xsl:value-of select="..//packagedElement[@xmi:type = 'uml:Class'][@xmi:id = current()/supplier/@xmi:idref]/@name"/>
	</xsl:variable>
	<xsl:variable name="client_name">
	  <xsl:value-of select="..//packagedElement[@xmi:type = 'uml:Class'][@xmi:id = current()/client/@xmi:idref]/@name"/>
	</xsl:variable>

	<xsl:text>&#9;&#9;</xsl:text> <!-- 2x tab -->
	<xsl:element name="dep"> <!-- creates the dep element with id="dep_" independent="prp_" dependent="prp_"-->
	  <xsl:attribute name="id"><xsl:text>dep_</xsl:text><xsl:value-of select="substring(generate-id(.),3)"/></xsl:attribute>
	  <xsl:attribute name="independent">
		<xsl:text>prp_</xsl:text><xsl:value-of select="substring(generate-id(key('ref_prop',$supplier_name)),3)"/>
	  </xsl:attribute>
	  <xsl:attribute name="dependent">
		<xsl:text>prp_</xsl:text><xsl:value-of select="substring(generate-id(key('ref_prop',$client_name)),3)"/>
	  </xsl:attribute>
	</xsl:element>
	<xsl:text>&#xa;</xsl:text> <!-- new line -->
  </xsl:for-each>
  <xsl:text>&#9;</xsl:text> <!-- 1x tab -->
 </xsl:element><!-- end of the ard element -->

</xsl:template>
</xsl:stylesheet>

