<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" xmlns:xmi="http://schema.omg.org/spec/XMI/2.1" xmlns:uml="http://schema.omg.org/spec/UML/2.2" xmlns:set="http://exslt.org/sets" xmlns:str="http://exslt.org/strings">
<xsl:output method="xml" doctype-system="hml.dtd" version="1.0" indent="yes" /> 

<xsl:key name="attribute" match="//node[@xmi:type = 'uml:ActivityParameterNode']" use="@name"/>    

<xsl:template match="/">
	<xsl:comment>Created with HeKatE Translator (XMIv2.1 to XTTML) v1.6 alpha</xsl:comment>     
    <xsl:variable name="higherLevelDiagram" select="//ownedBehavior[@xmi:type='uml:Activity'][node[@xmi:type='uml:CallBehaviorAction']]/@xmi:id|//packagedElement[@xmi:type='uml:Activity'][node[@xmi:type='uml:CallBehaviorAction']]/@xmi:id"></xsl:variable>
	<xsl:element name="hml">
	    <xsl:attribute name="version"><xsl:text>2.0</xsl:text></xsl:attribute>
	    <!--<xsl:element name="types">
	        <xsl:text>&#xa;</xsl:text>
	        <xsl:element name="type">
	            <xsl:attribute name="id">tpe_1</xsl:attribute>
	            <xsl:attribute name="name">default</xsl:attribute>
	            <xsl:attribute name="base">symbolic</xsl:attribute>
	        </xsl:element>
	    </xsl:element>-->	    
	    <xsl:element name="attributes">
	        <xsl:text>&#xa;</xsl:text> <!-- new line -->
	        <xsl:for-each select="set:distinct(//node[@xmi:type = 'uml:ActivityParameterNode']/@name)">
	            <xsl:text>&#9;</xsl:text> <!-- 1x tab -->
	            <xsl:element name="attr">
	                <xsl:attribute name="name"><xsl:value-of select="."/></xsl:attribute>	
	                <xsl:attribute name="type"><xsl:text></xsl:text></xsl:attribute>	
	                <xsl:attribute name="class"><xsl:text>simple</xsl:text></xsl:attribute>	
	                <xsl:attribute name="id"><xsl:text>att_</xsl:text><xsl:value-of select="substring(generate-id(key('attribute',.)[1]),3)"/></xsl:attribute>
	            </xsl:element>
	            <xsl:text>&#xa;</xsl:text> <!-- new line -->
	        </xsl:for-each>
	        <xsl:text>  </xsl:text>  <!-- 2 space -->
	    </xsl:element>
	    <xsl:element name="xtt">
	        <xsl:apply-templates select="//ownedBehavior[@xmi:id != $higherLevelDiagram]"> 
	            <xsl:with-param name="higherLevelDiagram" select="$higherLevelDiagram"/>    
	        </xsl:apply-templates>
	        <!-- if another type of XMI activities can be packagedElements -->
	        <xsl:if test="count(//ownedBehavior[@xmi:id != $higherLevelDiagram])=0">
	            <xsl:apply-templates select="//packagedElement[@xmi:id != $higherLevelDiagram]"> 
	                <xsl:with-param name="higherLevelDiagram" select="$higherLevelDiagram"/>    
	            </xsl:apply-templates>	            
	        </xsl:if>
	    </xsl:element>
	</xsl:element>
</xsl:template>
    
    <xsl:template name="setGuardValue">
        <xsl:param name="guard">0</xsl:param>
        
        <xsl:variable name="guardRelation">
            <xsl:choose>
                <xsl:when test="starts-with($guard,'in ')"><xsl:text>in </xsl:text></xsl:when>
                <xsl:when test="starts-with($guard,'notIn ')"><xsl:text>notIn </xsl:text></xsl:when>                
                <xsl:when test="starts-with($guard,'&lt;= ')"><xsl:text>&lt;= </xsl:text></xsl:when>
                <xsl:when test="starts-with($guard,'&lt; ')"><xsl:text>&lt; </xsl:text></xsl:when>
                <xsl:when test="starts-with($guard,'&gt;= ')"><xsl:text>&gt;= </xsl:text></xsl:when>                
                <xsl:when test="starts-with($guard,'&gt; ')"><xsl:text>&gt; </xsl:text></xsl:when>
                <xsl:when test="starts-with($guard,'!= ')"><xsl:text>!= </xsl:text></xsl:when>
                <xsl:when test="starts-with($guard,'= ')"><xsl:text>= </xsl:text></xsl:when>
                <xsl:when test="starts-with($guard,'sim ')"><xsl:text>sim </xsl:text></xsl:when>
                <xsl:when test="starts-with($guard,'notSim ')"><xsl:text>notSim </xsl:text></xsl:when>
                <xsl:when test="starts-with($guard,'subsetOf ')"><xsl:text>subsetOf </xsl:text></xsl:when>
                <xsl:when test="starts-with($guard,'supsetOf ')"><xsl:text>supsetOf </xsl:text></xsl:when>
                <xsl:otherwise><xsl:text></xsl:text></xsl:otherwise>
            </xsl:choose>                                                  
        </xsl:variable>

        <xsl:variable name="guardValue">
            <xsl:value-of select="substring-after($guard, $guardRelation)"/>
        </xsl:variable>    
        
        <xsl:choose>
            <xsl:when test="$guardRelation != 'in ' and $guardRelation != 'notIn '">
                    <xsl:text>&#xa;&#9;&#9;&#9;&#9;</xsl:text>  <!-- new line -->
                    <xsl:element name="value">
                    <xsl:attribute name="is"><xsl:value-of select="$guardValue"/></xsl:attribute>
                    </xsl:element>
                </xsl:when>
                <xsl:otherwise>
                    <xsl:for-each select="str:tokenize($guardValue,';')">
                        <xsl:text>&#xa;&#9;&#9;&#9;&#9;</xsl:text>  <!-- new line -->
                        <xsl:element name="value">
                            <xsl:choose>
                                <xsl:when test="contains(., ',')">
                                    <xsl:attribute name="from"><xsl:value-of select="substring-before($guardValue, ',')"/></xsl:attribute>
                                    <xsl:attribute name="to"><xsl:value-of select="substring-after($guardValue, ',')"/></xsl:attribute>                                                                
                                </xsl:when>
                                <xsl:otherwise>
                                    <xsl:attribute name="is"><xsl:value-of select="." /></xsl:attribute>                                                               
                                </xsl:otherwise>
                            </xsl:choose>                                                        
                        </xsl:element>
                    </xsl:for-each>                                       
                </xsl:otherwise>
        </xsl:choose>                        
    </xsl:template>    
    
    <xsl:template name="findOutputParameter">
        <xsl:param name="source">0</xsl:param>
        <xsl:param name="action">0</xsl:param>       
        
        <xsl:if test="$source = ../edge/@source">
            <xsl:variable name="target_id">
                <xsl:value-of select="../edge[@source = $source]/@target"/>
            </xsl:variable>            
            
            <xsl:if test="../node[@xmi:id = $target_id]/@xmi:type = 'uml:ActivityParameterNode' ">
                <xsl:text>&#xa;&#9;&#9;&#9;</xsl:text>  <!-- new line -->                
                <xsl:element name="attref">
                    <xsl:attribute name="ref"><xsl:text>att_</xsl:text><xsl:value-of select="substring(generate-id(key('attribute',../node[@xmi:id = $target_id]/@name)[1]),3)"/></xsl:attribute>
                </xsl:element>
                <xsl:text>&#xa;&#9;&#9;&#9;</xsl:text>  <!-- new line -->
                <xsl:element name="set">
                    <xsl:text>&#xa;&#9;&#9;&#9;&#9;</xsl:text>  <!-- new line -->
                    <xsl:element name="value">
                        <xsl:attribute name="is"><xsl:value-of select="$action"/></xsl:attribute>
                    </xsl:element>
                    <xsl:text>&#xa;&#9;&#9;&#9;</xsl:text>  <!-- new line -->
                </xsl:element>
            </xsl:if>           
            
            <xsl:variable name="setAction">
                <xsl:choose>
                    <xsl:when test="../node[@xmi:id = $target_id]/@xmi:type = 'uml:OpaqueAction'"><xsl:value-of select="../node[@xmi:id = $target_id]/@name"/></xsl:when>
                    <xsl:otherwise><xsl:value-of select="$action"/></xsl:otherwise>
                </xsl:choose>
            </xsl:variable>
            
            <xsl:if test="../node[@xmi:id = $target_id]/@xmi:type != 'uml:ActivityParameterNode' ">
            <xsl:call-template name="findOutputParameter">
                <xsl:with-param name="source" select="../edge[@source = $source]/@target"/>
                <xsl:with-param name="action" select="$setAction"/>                
            </xsl:call-template>
            </xsl:if>            
        </xsl:if>
        
    </xsl:template>    

    <xsl:template name="findInputParameter">
        <xsl:param name="source">0</xsl:param>
        <xsl:param name="target">0</xsl:param>
        <xsl:param name="guard">0</xsl:param>    
        <xsl:param name="relation">0</xsl:param>    
                
        <xsl:variable name="setGuard">
            <xsl:choose>                
                <xsl:when test="count(../edge[@target = $target]/guard)>0"><xsl:value-of select="../edge[@target = $target]/guard/@value"/></xsl:when>
                <xsl:when test="count(../edge[@target = $source]/guard)>0"><xsl:value-of select="../edge[@target = $source]/guard/@value"/></xsl:when>
                <xsl:otherwise><xsl:value-of select="$guard"/></xsl:otherwise>
            </xsl:choose>                      
        </xsl:variable>

        <xsl:variable name="setRelation">
            <xsl:choose>
                <xsl:when test="starts-with($setGuard,'in ')"><xsl:text>in</xsl:text></xsl:when>
                <xsl:when test="starts-with($setGuard,'notIn ')"><xsl:text>notin</xsl:text></xsl:when>
                <xsl:when test="starts-with($setGuard,'&lt;= ')"><xsl:text>lte</xsl:text></xsl:when>
                <xsl:when test="starts-with($setGuard,'&lt; ')"><xsl:text>lt</xsl:text></xsl:when>
                <xsl:when test="starts-with($setGuard,'&gt;= ')"><xsl:text>gte</xsl:text></xsl:when>
                <xsl:when test="starts-with($setGuard,'&gt; ')"><xsl:text>gt</xsl:text></xsl:when>                               
                <xsl:when test="starts-with($setGuard,'sim ')"><xsl:text>sim</xsl:text></xsl:when>
                <xsl:when test="starts-with($setGuard,'notSim ')"><xsl:text>notsim</xsl:text></xsl:when>
                <xsl:when test="starts-with($setGuard,'subsetOf ')"><xsl:text>subseteq</xsl:text></xsl:when>
                <xsl:when test="starts-with($setGuard,'supsetOf ')"><xsl:text>supseteq</xsl:text></xsl:when>                
                <xsl:when test="starts-with($setGuard,'!= ')"><xsl:text>neq</xsl:text></xsl:when>
                <xsl:otherwise><xsl:text>eq</xsl:text></xsl:otherwise>
            </xsl:choose>                
        </xsl:variable>       

        <xsl:if test="$target = ../edge/@target">
            <xsl:variable name="source_id">
                <xsl:value-of select="../edge[@target = $target]/@source"/>
            </xsl:variable>

            <xsl:if test="../node[@xmi:id = $source_id]/@xmi:type = 'uml:ActivityParameterNode' ">
                <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
                <xsl:element name="relation"> 
                    <xsl:attribute name="name"><xsl:value-of select="$setRelation"/></xsl:attribute>
                <xsl:text>&#xa;&#9;&#9;&#9;</xsl:text>  <!-- new line -->                
                <xsl:element name="attref">
                    <xsl:attribute name="ref"><xsl:text>att_</xsl:text><xsl:value-of select="substring(generate-id(key('attribute',../node[@xmi:id = $source_id]/@name)[1]),3)"/></xsl:attribute>
                </xsl:element>
                <xsl:text>&#xa;&#9;&#9;&#9;</xsl:text>  <!-- new line -->
                <xsl:element name="set">
                        <xsl:call-template name="setGuardValue">
                            <xsl:with-param name="guard" select="$setGuard"/>     
                        </xsl:call-template>                        
                    <xsl:text>&#xa;&#9;&#9;&#9;</xsl:text>  <!-- new line -->
                </xsl:element>
                <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
                </xsl:element>
            </xsl:if>     
 
            <xsl:if test="../node[@xmi:id = $source_id]/@xmi:type != 'uml:ActivityParameterNode' ">
                <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
            <xsl:call-template name="findInputParameter">             
                <xsl:with-param name="target" select="../edge[@target = $target]/@source"/>
                <xsl:with-param name="guard" select="$setGuard"/>     
                <xsl:with-param name="relation" select="$setRelation"/>     
            </xsl:call-template>
            </xsl:if>
            
        </xsl:if>
    </xsl:template>

    <xsl:template name="nextTable">   
        <xsl:param name="from">0</xsl:param>
        <xsl:param name="higherLevelDiagram">0</xsl:param>   
 
        <xsl:for-each select="//node()[@xmi:id = $higherLevelDiagram]/node[@xmi:id = ../edge[@source = $from]/@target]">                      
            <xsl:if test="@xmi:type = 'uml:JoinNode'">
                <xsl:call-template name="nextTable"><!-- mozna dodatkowo sprawdzic czy istnieje target -->
                    <xsl:with-param name="from" select="../edge[@source = $from]/@target"/>
                    <xsl:with-param name="higherLevelDiagram" select="$higherLevelDiagram"/>                          
                </xsl:call-template>                                                        
            </xsl:if>
            <xsl:if test="@xmi:type = 'uml:CallBehaviorAction' ">
                <xsl:for-each select="//ownedBehavior[@xmi:type='uml:Activity'][@name = current()/@name]">           
                <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
                <xsl:element name="link">
                    <xsl:text>&#xa;&#9;&#9;&#9;</xsl:text>  <!-- new line -->
                    <xsl:element name="tabref">
                        <xsl:attribute name="ref"><xsl:text>tab_</xsl:text>
                            <xsl:value-of select="substring(generate-id(.),3)"/>
                        </xsl:attribute>                        
                    </xsl:element>    
                    <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
                </xsl:element> 
                </xsl:for-each>
                <!-- if another type of XMI activities can be packagedElements -->
                <xsl:if test="count(//ownedBehavior[@xmi:type='uml:Activity'][@name = current()/@name])=0">
                    <xsl:for-each select="//packagedElement[@xmi:type='uml:Activity'][@name = current()/@name]">           
                        <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
                        <xsl:element name="link">
                            <xsl:text>&#xa;&#9;&#9;&#9;</xsl:text>  <!-- new line -->
                            <xsl:element name="tabref">
                                <xsl:attribute name="ref"><xsl:text>tab_</xsl:text>
                                    <xsl:value-of select="substring(generate-id(.),3)"/>
                                </xsl:attribute>                        
                            </xsl:element>    
                            <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
                        </xsl:element> 
                    </xsl:for-each>      
                </xsl:if>               
            </xsl:if>    
        </xsl:for-each>
    </xsl:template>


<xsl:template match="packagedElement[@xmi:type='uml:Activity']|ownedBehavior[@xmi:type='uml:Activity']">
    <xsl:param name="higherLevelDiagram">0</xsl:param>   
    
    <xsl:variable name="tableName"><xsl:value-of select="@name"/></xsl:variable>
    <xsl:variable name="tableId"><xsl:value-of select="//node()[@xmi:id = $higherLevelDiagram]/node[@name = $tableName]/@xmi:id"/></xsl:variable>
   
    <xsl:element name="table">
    <xsl:attribute name="name"><xsl:value-of select="$tableName"/></xsl:attribute>
	<xsl:attribute name="id"><xsl:text>tab_</xsl:text><xsl:value-of select="substring(generate-id(.),3)"/></xsl:attribute>

    <xsl:text>&#xa;&#9;</xsl:text>  <!-- new line -->
	<!-- table schema -->
	<xsl:element name="schm">
	<!-- input -->
	<xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
	<xsl:element name="precondition">
		<xsl:for-each select=".//node[@xmi:type='uml:ActivityParameterNode'][@xmi:id = ../edge/@source]">
		    <xsl:text>&#xa;&#9;&#9;&#9;</xsl:text>  <!-- new line -->
			<xsl:element name="attref">
				<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
				<xsl:attribute name="ref"><xsl:text>att_</xsl:text><xsl:value-of select="substring(generate-id(key('attribute',@name)[1]),3)"/></xsl:attribute>
			</xsl:element>       
		</xsl:for-each>
	    <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
	</xsl:element> 
	<!-- output -->
	<xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
	<xsl:element name="conclusion">
		<xsl:for-each select=".//node[@xmi:type='uml:ActivityParameterNode'][@xmi:id = ../edge/@target]">
		    <xsl:text>&#xa;&#9;&#9;&#9;</xsl:text>  <!-- new line -->
			<xsl:element name="attref"> <!-- ma byc tylko ref z odniesieniem do id z ARD -->
				<xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
				<xsl:attribute name="ref"><xsl:text>att_</xsl:text><xsl:value-of select="substring(generate-id(key('attribute',@name)[1]),3)"/></xsl:attribute>
			</xsl:element>       
		</xsl:for-each>
	    <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
	</xsl:element> 
	<xsl:text>&#xa;&#9;</xsl:text>  <!-- new line -->
    </xsl:element> 
    
	<xsl:for-each select=".//node[@xmi:type='uml:JoinNode']">
	<xsl:variable name="source">
	    <xsl:value-of select="@xmi:id"/>
	</xsl:variable>
  	<xsl:text>&#xa;&#9;</xsl:text>  <!-- new line -->	    
		<xsl:element name="rule">
		    <xsl:attribute name="id"><xsl:text>rul_</xsl:text><xsl:value-of select="substring(generate-id(.),3)"/></xsl:attribute>

		    <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
		    <xsl:element name="condition">		        		        
		        <xsl:for-each select="../edge[@target = current()/@xmi:id]">
		            <xsl:call-template name="findInputParameter">
		                <xsl:with-param name="source" select="$source"/>
		                <xsl:with-param name="target" select="@source"/>
		            </xsl:call-template>   
		        </xsl:for-each>
		        
		        <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
		    </xsl:element>		    

		    <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
		    <xsl:element name="decision">
		        <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
		        <xsl:element name="trans">
		        <xsl:call-template name="findOutputParameter">
		            <xsl:with-param name="source" select="$source"/>
		        </xsl:call-template>
		            <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
		        </xsl:element>    
		        <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
		    </xsl:element>
		    
		    <xsl:if test="string-length(normalize-space($tableId)) != 0">
		        <xsl:call-template name="nextTable">
		            <xsl:with-param name="higherLevelDiagram" select="$higherLevelDiagram"/>
		            <xsl:with-param name="from" select="$tableId"/>
		        </xsl:call-template>     	        		        
		    </xsl:if>
		    
		    <xsl:text>&#xa;&#9;</xsl:text>  <!-- new line -->
		</xsl:element>	    	   
	</xsl:for-each>
                
    <xsl:if test="not(.//node[@xmi:type='uml:JoinNode'])">       
        <xsl:for-each select=".//node[@xmi:type='uml:OpaqueAction']">
            <xsl:variable name="source">
                <xsl:value-of select="@xmi:id"/>
            </xsl:variable>
            <xsl:text>&#xa;&#9;</xsl:text>  <!-- new line -->	    
            <xsl:element name="rule">
                <xsl:attribute name="id"><xsl:text>rul_</xsl:text><xsl:value-of select="substring(generate-id(.),3)"/></xsl:attribute>
                
                <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
                <xsl:element name="condition">                                       
                    <xsl:call-template name="findInputParameter">
                        <xsl:with-param name="source" select="$source"/>
                        <xsl:with-param name="target" select="../edge[@target = current()/@xmi:id]/@source"/>
                    </xsl:call-template>                                                              
                    <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->                    
                </xsl:element>	
                
                <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
                <xsl:element name="decision">
                    <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
                    <xsl:element name="trans">
                        <xsl:call-template name="findOutputParameter">
                            <xsl:with-param name="source" select="$source"/>
                            <xsl:with-param name="action" select="@name"/>    
                        </xsl:call-template>
                        <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
                    </xsl:element>                                           
                    <xsl:text>&#xa;&#9;&#9;</xsl:text>  <!-- new line -->
                </xsl:element>
                
                <xsl:if test="string-length(normalize-space($tableId)) != 0">
                    <xsl:call-template name="nextTable">
                        <xsl:with-param name="higherLevelDiagram" select="$higherLevelDiagram"/>
                        <xsl:with-param name="from" select="$tableId"/>
                    </xsl:call-template>     	        		        
                </xsl:if>
                
                <xsl:text>&#xa;&#9;</xsl:text>  <!-- new line -->
            </xsl:element>	   
        </xsl:for-each>
    </xsl:if>    
        
  <xsl:text>&#xa;  </xsl:text>  <!-- new line -->
  </xsl:element>
</xsl:template>

</xsl:stylesheet>

