<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0" 
    xmlns:uml="http://schema.omg.org/spec/UML/2.2" 
    xmlns:xmi="http://schema.omg.org/spec/XMI/2.1"    
    xmlns:set="http://exslt.org/sets">
<xsl:output method="xml" version="1.0" indent="yes" /> 
<xsl:template match="/">
	<xsl:comment>Created with HeKatE Translator (XTTML to XMIv2.1) v1.2.1 alpha</xsl:comment>
    <!-- XMI header for XMI ver. 2.1 and UML ver. 2.2 -->
	<xsl:element name="xmi:XMI">
	    <xsl:attribute name="xmi:version">2.1</xsl:attribute>
	    <xsl:attribute name="uml:package">hml</xsl:attribute>
	    <xsl:element name="xmi:Documentation">
	       <xsl:attribute name="contact">hekate.ia.agh.edu.pl</xsl:attribute>
	       <xsl:attribute name="exporter">HeKatE Translator (XTTML to XMIv2.1)</xsl:attribute>
	    </xsl:element>
	       <xsl:element name="uml:Package">
	           <xsl:attribute name="name">hml</xsl:attribute>
	           <xsl:attribute name="xmi:id">hml</xsl:attribute>	           	             
	               <xsl:call-template name="domainDiagram" />	               
<!--	           <xsl:element name="packagedElement">
	               <xsl:attribute name="name">xtt</xsl:attribute>
	               <xsl:attribute name="xmi:id">xtt</xsl:attribute>
	               <xsl:attribute name="xmi:type">uml:Package</xsl:attribute>
	               <xsl:attribute name="visibility">public</xsl:attribute>-->
	               <xsl:apply-templates select="//hml/xtt"/>
<!--	           </xsl:element>-->	               	          	      
	       </xsl:element>	 
	</xsl:element>
</xsl:template>

<xsl:template match="//hml/xtt">
    <xsl:apply-templates select="./table"/>
    
    <xsl:call-template name="higherDiagram">
        <xsl:with-param name="path" select="."/>     
    </xsl:call-template>
    <!-- <xsl:element name="higherDiagram"></xsl:element> -->
</xsl:template>

<xsl:template match="//hml/xtt/table">
    <xsl:variable name="tableName">
        <xsl:value-of select="@name"/>
    </xsl:variable>
    <!-- create table -->
    <xsl:element name="packagedElement">
        <xsl:attribute name="name"><xsl:value-of select="$tableName"/></xsl:attribute>
        <xsl:attribute name="xmi:id"><xsl:text>pkg_</xsl:text><xsl:value-of select="@name"/></xsl:attribute>
        <xsl:attribute name="xmi:type">uml:Activity</xsl:attribute>
        <xsl:attribute name="visibility">public</xsl:attribute>
        <xsl:if test="./desc">
            <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->   
            <xsl:comment><xsl:value-of select="./desc"/></xsl:comment>
        </xsl:if>
        <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
        <xsl:element name="ownedBehavior">
            <xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
            <xsl:attribute name="xmi:id"><xsl:text>ob_pkg_</xsl:text><xsl:value-of select="@name"/></xsl:attribute>
            <xsl:attribute name="xmi:type">uml:Activity</xsl:attribute>
            <xsl:attribute name="visibility">public</xsl:attribute>
            <!--<xsl:apply-templates/>-->            
            
            <xsl:for-each select="./schm/precondition/attref">
                <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                <!-- activity parameter node -->
                <xsl:element name="node">
                    <xsl:attribute name="xmi:type">uml:ActivityParameterNode</xsl:attribute>
                    <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/>_ipn_<xsl:value-of select="@ref"/></xsl:attribute>
                    <xsl:attribute name="name"><xsl:value-of select="//hml/attributes/attr[@id = current()/@ref]/@name"/></xsl:attribute>                               
                    <!-- POPRAW     <xsl:element name="outgoing">
                        <xsl:attribute name="xmi:idref"><xsl:text>ed_</xsl:text>TUIDODPOWIEDNIEGOEDGA!</xsl:attribute>
                        </xsl:element> -->
                </xsl:element>
                <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                <!-- decision node -->
                <xsl:element name="node">
                    <xsl:attribute name="xmi:type">uml:DecisionNode</xsl:attribute>
                    <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/>_dn_<xsl:value-of select="@ref"/></xsl:attribute>
                    <xsl:attribute name="name">DecisionNode</xsl:attribute>                               
                    <!-- POPRAW     <xsl:element name="outgoing">
                        <xsl:attribute name="xmi:idref"><xsl:text>ed_</xsl:text>TUIDODPOWIEDNIEGOEDGA!</xsl:attribute>
                        </xsl:element> -->
                </xsl:element>
                <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                <!-- ipn~~~dn edge -->
                <xsl:element name="edge">
                    <xsl:attribute name="xmi:type">uml:ObjectFlow</xsl:attribute>
                    <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/><xsl:text>_e1_</xsl:text><xsl:value-of select="@ref"/></xsl:attribute>
                    <xsl:attribute name="source"><xsl:value-of select="$tableName"/>_ipn_<xsl:value-of select="@ref"/></xsl:attribute>
                    <xsl:attribute name="target"><xsl:value-of select="$tableName"/>_dn_<xsl:value-of select="@ref"/></xsl:attribute>
                </xsl:element>
            </xsl:for-each>   

            <!-- activity with one input parameter -->
            <xsl:if test="count(./schm/precondition/attref)=1">               
                <xsl:call-template name="simpleActivity">
                    <xsl:with-param name="path" select="."/>     
                    <xsl:with-param name="dnRef" select="./schm/precondition/attref/@ref"/>                        
                    <xsl:with-param name="tableName" select="$tableName"/>   
                </xsl:call-template>
            </xsl:if>   
            
            <!-- activity with more than one input parameter -->
            <xsl:if test="count(./schm/precondition/attref)>1">               
                <xsl:call-template name="complexActivity">
                    <xsl:with-param name="path" select="."/>     
                    <xsl:with-param name="dnRef" select="./schm/precondition/attref/@ref"/>                        
                    <xsl:with-param name="tableName" select="$tableName"/>   
                </xsl:call-template>
            </xsl:if>   
                                 
        <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
        </xsl:element>     
    <xsl:text>&#xa;&#xa0;&#xa0;&#xa0;&#xa0;</xsl:text> <!-- new line + tab -->
    </xsl:element>	 
</xsl:template>




    <xsl:template name="simpleActivity"> 
        <xsl:param name="dnRef"/>
        <xsl:param name="path"/>
        <xsl:param name="tableName"/> 
                
        <xsl:for-each select="./rule">
            <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
            <!-- dn~~~oac edge -->
            <xsl:element name="edge">
                <xsl:attribute name="xmi:type">uml:ObjectFlow</xsl:attribute>
                <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/><xsl:text>_e2_</xsl:text><xsl:value-of select="@id"/></xsl:attribute>                        
                <xsl:attribute name="source"><xsl:value-of select="$tableName"/>_dn_<xsl:value-of select="$dnRef"/></xsl:attribute>
                <xsl:attribute name="target"><xsl:value-of select="$tableName"/>_oac_<xsl:value-of select="@id"/></xsl:attribute>
                <xsl:element name="guard">
                    <xsl:attribute name="xmi:type">uml:LiteralString</xsl:attribute>
                    <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/><xsl:text>_g_</xsl:text><xsl:value-of select="@id"/></xsl:attribute>
                    <xsl:attribute name="value"><xsl:value-of select="./condition/relation"/></xsl:attribute>
                </xsl:element>
            </xsl:element>
            <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
            <!-- opaque action node -->
            <xsl:element name="node">
                <xsl:attribute name="xmi:type">uml:OpaqueAction</xsl:attribute>
                <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/>_oac_<xsl:value-of select="@id"/></xsl:attribute>
                <xsl:attribute name="name"><xsl:value-of select="./decision/trans"/></xsl:attribute>
            </xsl:element>
            <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
            <!-- act~~~mrg edge -->     
            <xsl:element name="edge">
                <xsl:attribute name="xmi:type">uml:ObjectFlow</xsl:attribute>
                <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/><xsl:text>_e3_</xsl:text><xsl:value-of select="@id"/></xsl:attribute>                        
                <xsl:attribute name="source"><xsl:value-of select="$tableName"/>_oac_<xsl:value-of select="@id"/></xsl:attribute>
                <xsl:attribute name="target"><xsl:value-of select="$tableName"/>_mrg_<xsl:value-of select="./decision/trans/@attRef"/></xsl:attribute>                
            </xsl:element>
        </xsl:for-each>                    
        
        <xsl:for-each select="./schm/conclusion/attref">
            <!-- merge node -->
            <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
            <xsl:element name="node">
                <xsl:attribute name="xmi:type">uml:MergeNode</xsl:attribute>
                <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/>_mrg_<xsl:value-of select="@ref"/></xsl:attribute>
                <xsl:attribute name="name">MergeNode</xsl:attribute>                
            </xsl:element>   
            <!-- mrg~~~opn edge -->     
            <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
            <xsl:element name="edge">
                <xsl:attribute name="xmi:type">uml:ObjectFlow</xsl:attribute>
                <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/><xsl:text>_e4_</xsl:text><xsl:value-of select="@ref"/></xsl:attribute>                                        
                <xsl:attribute name="source"><xsl:value-of select="$tableName"/>_mrg_<xsl:value-of select="@ref"/></xsl:attribute>                
                <xsl:attribute name="target"><xsl:value-of select="$tableName"/>_opn_<xsl:value-of select="@ref"/></xsl:attribute>
            </xsl:element>
            <!-- activity parameter node -->
            <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
            <xsl:element name="node">
                <xsl:attribute name="xmi:type">uml:ActivityParameterNode</xsl:attribute>
                <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/>_opn_<xsl:value-of select="@ref"/></xsl:attribute>
                <xsl:attribute name="name"><xsl:value-of select="//hml/attributes/attr[@id = current()/@ref]/@name"/></xsl:attribute>                             
            </xsl:element>
        </xsl:for-each>          
    </xsl:template>
    
    
    
    
    <xsl:template name="complexActivity"> 
        <xsl:param name="dnRef"/>
        <xsl:param name="path"/>
        <xsl:param name="tableName"/> 
        
        <xsl:for-each select="./schm/precondition/attref">    
            <xsl:variable name="refAttr">
                <xsl:value-of select="@ref"/>
            </xsl:variable>

            <xsl:for-each select="set:distinct(../../../rule/condition/relation[@attRef = $refAttr])">
                <xsl:variable name="guardCondition">
                    <xsl:value-of select="."/>
                </xsl:variable>
                <xsl:variable name="id">
                    <xsl:value-of select="substring(generate-id(.),3)"/>
                </xsl:variable>
                
                <xsl:if test="count(../../../rule/condition/relation[@attRef = $refAttr][. = $guardCondition])=1">
                    <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                    <!-- dn~~~jn edge -->
                    <xsl:element name="edge">
                        <xsl:attribute name="xmi:type">uml:ObjectFlow</xsl:attribute>
                        <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/><xsl:text>_e2_</xsl:text><xsl:value-of select="$id"/></xsl:attribute>                        
                        <xsl:attribute name="source"><xsl:value-of select="$tableName"/>_dn_<xsl:value-of select="$refAttr"/></xsl:attribute> <!-- ./schm/precondition/attref/@ref -->
                        <xsl:attribute name="target"><xsl:value-of select="$tableName"/>_jn_<xsl:value-of select="../../@id"/></xsl:attribute>
                        <xsl:element name="guard">
                            <xsl:attribute name="xmi:type">uml:LiteralString</xsl:attribute>
                            <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/><xsl:text>_g_</xsl:text><xsl:value-of select="$id"/></xsl:attribute>
                            <xsl:attribute name="value"><xsl:value-of select="."/></xsl:attribute>
                        </xsl:element>
                    </xsl:element>                   
                </xsl:if>
                <xsl:if test="count(../../../rule/condition/relation[@attRef = $refAttr][. = $guardCondition])>1">
                    <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                    <!-- dn~~~fn edge -->
                    <xsl:element name="edge">
                        <xsl:attribute name="xmi:type">uml:ObjectFlow</xsl:attribute>
                        <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/><xsl:text>_e2_</xsl:text><xsl:value-of select="$id"/></xsl:attribute>                        
                        <xsl:attribute name="source"><xsl:value-of select="$tableName"/>_dn_<xsl:value-of select="$refAttr"/></xsl:attribute>
                        <xsl:attribute name="target"><xsl:value-of select="$tableName"/>_fn_<xsl:value-of select="$id"/></xsl:attribute>
                        <xsl:element name="guard">
                            <xsl:attribute name="xmi:type">uml:LiteralString</xsl:attribute>
                            <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/><xsl:text>_g_</xsl:text><xsl:value-of select="$id"/></xsl:attribute>
                            <xsl:attribute name="value"><xsl:value-of select="."/></xsl:attribute>
                        </xsl:element>
                    </xsl:element>        
                    <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                    <!-- fork node -->
                    <xsl:element name="node">
                        <xsl:attribute name="xmi:type">uml:ForkNode</xsl:attribute>
                        <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/>_fn_<xsl:value-of select="$id"/></xsl:attribute>
                        <xsl:attribute name="name">ForkNode</xsl:attribute>                
                    </xsl:element>   
                    <xsl:for-each select="../../../rule/condition/relation[@attRef = $refAttr][. = $guardCondition]">
                        <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                        <!-- fn~~~jn edge -->     
                        <xsl:element name="edge">
                            <xsl:attribute name="xmi:type">uml:ObjectFlow</xsl:attribute>
                            <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/><xsl:text>_e3_</xsl:text><xsl:value-of select="$id"/><xsl:value-of select="../../@id"/></xsl:attribute>                        
                            <xsl:attribute name="source"><xsl:value-of select="$tableName"/>_fn_<xsl:value-of select="$id"/></xsl:attribute>
                            <xsl:attribute name="target"><xsl:value-of select="$tableName"/>_jn_<xsl:value-of select="../../@id"/></xsl:attribute>                
                        </xsl:element>
                    </xsl:for-each>   
                </xsl:if>
            </xsl:for-each>                                        
        </xsl:for-each> 
        <xsl:for-each select="./rule"> 
            <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
            <!-- join node -->
            <xsl:element name="node">
                <xsl:attribute name="xmi:type">uml:JoinNode</xsl:attribute>
                <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/>_jn_<xsl:value-of select="@id"/></xsl:attribute>
                <xsl:attribute name="name">JoinNode</xsl:attribute>                
            </xsl:element>   
        </xsl:for-each>        
                       
        <xsl:for-each select="./schm/conclusion/attref">    
            <xsl:variable name="refAttr">
                <xsl:value-of select="@ref"/>
            </xsl:variable>
            <xsl:for-each select="set:distinct(../../../rule/decision/trans[@attRef = $refAttr])">
                <xsl:variable name="action">
                    <xsl:value-of select="."/>
                </xsl:variable>
                <xsl:variable name="id">
                    <xsl:value-of select="substring(generate-id(.),3)"/>
                </xsl:variable>
                <xsl:if test="count(../../../rule/decision/trans[@attRef = $refAttr][. = $action])=1">
                    <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                    <!-- jn~~~oac edge -->
                    <xsl:element name="edge">
                        <xsl:attribute name="xmi:type">uml:ObjectFlow</xsl:attribute>
                        <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/><xsl:text>_e4_</xsl:text><xsl:value-of select="$id"/></xsl:attribute>                                                
                        <xsl:attribute name="source"><xsl:value-of select="$tableName"/>_jn_<xsl:value-of select="../../@id"/></xsl:attribute>
                        <xsl:attribute name="target"><xsl:value-of select="$tableName"/>_oac_<xsl:value-of select="$id"/></xsl:attribute>
                    </xsl:element>                                
                </xsl:if>
                <xsl:if test="count(../../../rule/decision/trans[@attRef = $refAttr][. = $action])>1">
                    <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                    <!-- mrg~~~oac edge -->
                    <xsl:element name="edge">
                        <xsl:attribute name="xmi:type">uml:ObjectFlow</xsl:attribute>
                        <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/><xsl:text>_e5_</xsl:text><xsl:value-of select="$id"/></xsl:attribute>                                                
                        <xsl:attribute name="source"><xsl:value-of select="$tableName"/>_mrg1_<xsl:value-of select="$id"/></xsl:attribute>
                        <xsl:attribute name="target"><xsl:value-of select="$tableName"/>_oac_<xsl:value-of select="$id"/></xsl:attribute>
                    </xsl:element>
                    <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                    <!-- merge node -->
                    <xsl:element name="node">
                        <xsl:attribute name="xmi:type">uml:MergeNode</xsl:attribute>
                        <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/>_mrg1_<xsl:value-of select="$id"/></xsl:attribute>
                        <xsl:attribute name="name">MergeNode</xsl:attribute>                
                    </xsl:element>  
                    <xsl:for-each select="../../../rule/decision/trans[@attRef = $refAttr][. = $action]">
                        <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                        <!-- jn~~~mrg edge -->     
                        <xsl:element name="edge">
                            <xsl:attribute name="xmi:type">uml:ObjectFlow</xsl:attribute>
                            <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/><xsl:text>_e4_</xsl:text><xsl:value-of select="$id"/><xsl:value-of select="../../@id"/></xsl:attribute>                        
                            <xsl:attribute name="source"><xsl:value-of select="$tableName"/>_jn_<xsl:value-of select="../../@id"/></xsl:attribute>
                            <xsl:attribute name="target"><xsl:value-of select="$tableName"/>_mrg1_<xsl:value-of select="$id"/></xsl:attribute>                
                        </xsl:element>
                    </xsl:for-each>   
                </xsl:if>
                <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                <!-- opaque action node -->
                <xsl:element name="node">
                    <xsl:attribute name="xmi:type">uml:OpaqueAction</xsl:attribute>
                    <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/>_oac_<xsl:value-of select="$id"/></xsl:attribute>
                    <xsl:attribute name="name"><xsl:value-of select="$action"/></xsl:attribute>
                </xsl:element>
                <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                <!-- oac~~~mrg edge -->     
                <xsl:element name="edge">
                    <xsl:attribute name="xmi:type">uml:ObjectFlow</xsl:attribute>
                    <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/><xsl:text>_e6_</xsl:text><xsl:value-of select="$id"/><xsl:value-of select="../../@id"/></xsl:attribute>                        
                    <xsl:attribute name="source"><xsl:value-of select="$tableName"/>_oac_<xsl:value-of select="$id"/></xsl:attribute>
                    <xsl:attribute name="target"><xsl:value-of select="$tableName"/>_mrg2_<xsl:value-of select="$refAttr"/></xsl:attribute>                
                </xsl:element>                
            </xsl:for-each>  
            <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
            <!-- merge node -->
            <xsl:element name="node">
                <xsl:attribute name="xmi:type">uml:MergeNode</xsl:attribute>
                <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/>_mrg2_<xsl:value-of select="$refAttr"/></xsl:attribute>
                <xsl:attribute name="name">MergeNode</xsl:attribute>                
            </xsl:element>  
            <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
            <!-- mrg~~~opn edge -->     
            <xsl:element name="edge">
                <xsl:attribute name="xmi:type">uml:ObjectFlow</xsl:attribute>
                <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/><xsl:text>_e7_</xsl:text><xsl:value-of select="$refAttr"/></xsl:attribute>                        
                <xsl:attribute name="source"><xsl:value-of select="$tableName"/>_mrg2_<xsl:value-of select="$refAttr"/></xsl:attribute>
                <xsl:attribute name="target"><xsl:value-of select="$tableName"/>_opn_<xsl:value-of select="$refAttr"/></xsl:attribute>                
            </xsl:element>
            <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
            <!-- activity parameter node -->
            <xsl:element name="node">
                <xsl:attribute name="xmi:type">uml:ActivityParameterNode</xsl:attribute>
                <xsl:attribute name="xmi:id"><xsl:value-of select="$tableName"/>_opn_<xsl:value-of select="$refAttr"/></xsl:attribute>
                <xsl:attribute name="name"><xsl:value-of select="//hml/attributes/attr[@id = $refAttr]/@name"/></xsl:attribute>                             
            </xsl:element>
        </xsl:for-each>          
    </xsl:template>
    
    
    
    
    
    <xsl:template name="higherDiagram"> 
        <xsl:param name="path"/>

        <!-- create higher level table -->
        <xsl:element name="packagedElement">
            <xsl:attribute name="name">higherDiagram</xsl:attribute>
            <xsl:attribute name="xmi:id">pkg_higherDiagram</xsl:attribute>
            <xsl:attribute name="xmi:type">uml:Activity</xsl:attribute>
            <xsl:attribute name="visibility">public</xsl:attribute>
            <xsl:element name="ownedBehavior">
                <xsl:attribute name="name">higherDiagram</xsl:attribute>
                <xsl:attribute name="xmi:id">ob_pkg_higherDiagram</xsl:attribute>
                <xsl:attribute name="xmi:type">uml:Activity</xsl:attribute>
                <xsl:attribute name="visibility">public</xsl:attribute>
            
                <xsl:for-each select="./table">
                    <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                    <!-- callbehavior action node -->
                    <xsl:element name="node">
                        <xsl:attribute name="xmi:type">uml:CallBehaviorAction</xsl:attribute>
                        <xsl:attribute name="xmi:id">cba_<xsl:value-of select="@name"/></xsl:attribute>
                        <xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
                        <xsl:attribute name="behavior">pkg_<xsl:value-of select="@name"/></xsl:attribute>                        
                    </xsl:element>
                                        
                    <xsl:variable name="from">
                        <xsl:value-of select="@name"/>
                    </xsl:variable>                  
                    <xsl:for-each select="set:distinct(./rule/link/tabref/@ref)">
                        <xsl:variable name="name">
                            <xsl:value-of select="//hml/xtt/table[@id = current()]/@name"/>
                        </xsl:variable>                        
                        <xsl:if test="count(//hml/xtt/table[./rule/link/tabref/@ref = current()])>1">
                            <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                            <!-- cba~~~jn edge -->
                            <xsl:element name="edge">
                                <xsl:attribute name="xmi:type">uml:ObjectFlow</xsl:attribute>
                                <xsl:attribute name="xmi:id">e2_<xsl:value-of select="$from"/>2<xsl:value-of select="$name"/></xsl:attribute>                                                
                                <xsl:attribute name="source">cba_<xsl:value-of select="$from"/></xsl:attribute>
                                <xsl:attribute name="target">jn_<xsl:value-of select="$name"/></xsl:attribute>
                            </xsl:element>
                        </xsl:if>
                        <xsl:if test="count(//hml/xtt/table[./rule/link/tabref/@ref = current()])=1">
                            <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                            <!-- cba~~~cba edge -->
                            <xsl:element name="edge">
                                <xsl:attribute name="xmi:type">uml:ObjectFlow</xsl:attribute>
                                <xsl:attribute name="xmi:id">e2_<xsl:value-of select="$name"/></xsl:attribute>                                                
                                <xsl:attribute name="source">cba_<xsl:value-of select="$from"/></xsl:attribute>
                                <xsl:attribute name="target">cba_<xsl:value-of select="$name"/></xsl:attribute>
                            </xsl:element>
                        </xsl:if>
                    </xsl:for-each>                   
                </xsl:for-each>
                                
                <!-- jesli wiecej niz 1 tabela linkuje do danej tabeli tworzy join node -->
                <xsl:for-each select="set:distinct(./table/rule/link/tabref/@ref)">
                    <xsl:variable name="name">
                        <xsl:value-of select="//hml/xtt/table[@id = current()]/@name"/>
                    </xsl:variable>
                    <xsl:if test="count(//hml/xtt/table[./rule/link/tabref/@ref = current()])>1">
                        <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                        <!-- join node -->
                        <xsl:element name="node">
                            <xsl:attribute name="xmi:type">uml:JoinNode</xsl:attribute>
                            <xsl:attribute name="xmi:id">jn_<xsl:value-of select="$name"/></xsl:attribute>
                            <xsl:attribute name="name">JoinNode</xsl:attribute>                
                        </xsl:element>   
                        <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                        <!-- jn~~~cba edge -->
                        <xsl:element name="edge">
                            <xsl:attribute name="xmi:type">uml:ObjectFlow</xsl:attribute>
                            <xsl:attribute name="xmi:id">e3_<xsl:value-of select="$name"/></xsl:attribute>                                                
                            <xsl:attribute name="source">jn_<xsl:value-of select="$name"/></xsl:attribute>
                            <xsl:attribute name="target">cba_<xsl:value-of select="$name"/></xsl:attribute>
                        </xsl:element>                          
                    </xsl:if>
                </xsl:for-each>    
            
                <!-- input activity parameter nodes -->
                <xsl:for-each select="set:distinct(./table/schm/precondition/attref/@ref)">
                    <xsl:variable name="name">
                        <xsl:value-of select="//hml/attributes/attr[@id = current()]/@name"/>
                    </xsl:variable>
                    <xsl:if test="not(//hml/xtt/table/schm/conclusion/attref[@ref = current()])">
                        <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                        <!-- activity parameter node -->
                        <xsl:element name="node">
                            <xsl:attribute name="xmi:type">uml:ActivityParameterNode</xsl:attribute>
                            <xsl:attribute name="xmi:id">ipn_<xsl:value-of select="current()"/></xsl:attribute>
                            <xsl:attribute name="name"><xsl:value-of select="$name"/></xsl:attribute>                             
                        </xsl:element>
                        <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                        <!-- ipn~~~cba edge -->
                        <xsl:element name="edge">
                            <xsl:attribute name="xmi:type">uml:ObjectFlow</xsl:attribute>
                            <xsl:attribute name="xmi:id">e1_<xsl:value-of select="current()"/></xsl:attribute>                                                
                            <xsl:attribute name="source">ipn_<xsl:value-of select="current()"/></xsl:attribute>
                            <xsl:attribute name="target">cba_<xsl:value-of select="../../../../@name"/></xsl:attribute>
                        </xsl:element>                        
                    </xsl:if>                    
                </xsl:for-each>
                
                <!-- output activity parameter nodes -->
                <xsl:for-each select="set:distinct(./table/schm/conclusion/attref/@ref)">
                    <xsl:variable name="name">
                        <xsl:value-of select="//hml/attributes/attr[@id = current()]/@name"/>
                    </xsl:variable>
                    <xsl:if test="not(//hml/xtt/table/schm/precondition/attref[@ref = current()])">
                        <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                        <!-- activity parameter node -->
                        <xsl:element name="node">
                            <xsl:attribute name="xmi:type">uml:ActivityParameterNode</xsl:attribute>
                            <xsl:attribute name="xmi:id">opn_<xsl:value-of select="current()"/></xsl:attribute>
                            <xsl:attribute name="name"><xsl:value-of select="$name"/></xsl:attribute>                             
                        </xsl:element>
                        <xsl:text>&#xa;&#9;</xsl:text> <!-- new line + tab -->
                        <!-- ipn~~~cba edge -->
                        <xsl:element name="edge">
                            <xsl:attribute name="xmi:type">uml:ObjectFlow</xsl:attribute>
                            <xsl:attribute name="xmi:id">e4_<xsl:value-of select="current()"/></xsl:attribute>                                                                           
                            <xsl:attribute name="source">cba_<xsl:value-of select="../../../../@name"/></xsl:attribute>
                            <xsl:attribute name="target">opn_<xsl:value-of select="current()"/></xsl:attribute>
                        </xsl:element>                        
                    </xsl:if>                    
                </xsl:for-each>
            
            
            </xsl:element>
        </xsl:element>
        
    </xsl:template>
    
    <xsl:template name="domainDiagram"> 
        <xsl:element name="packagedElement">
            <xsl:attribute name="name">Domain</xsl:attribute>
            <xsl:attribute name="xmi:id">domain_attributes_types</xsl:attribute>
            <xsl:attribute name="xmi:type">uml:Package</xsl:attribute>
            
            <xsl:element name="packagedElement">
                <xsl:attribute name="name">symbolic</xsl:attribute>
                <xsl:attribute name="xmi:id">symbolic</xsl:attribute>                   
                <xsl:attribute name="xmi:type">uml:DataType</xsl:attribute>
            </xsl:element>
            <xsl:element name="packagedElement">
                <xsl:attribute name="name">numeric</xsl:attribute>
                <xsl:attribute name="xmi:id">numeric</xsl:attribute>                   
                <xsl:attribute name="xmi:type">uml:DataType</xsl:attribute>
            </xsl:element>
            
            <xsl:element name="packagedElement">
                <xsl:attribute name="name">attributes</xsl:attribute>
                <xsl:attribute name="xmi:id">attributes</xsl:attribute>
                <xsl:attribute name="xmi:type">uml:Enumeration</xsl:attribute> 
                <xsl:for-each select="set:distinct(//hml/attributes/attr)">
                    <xsl:element name="ownedAttribute">                         
                        <xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>                      
                        <xsl:attribute name="xmi:id"><xsl:value-of select="@id"/></xsl:attribute>
                        <xsl:attribute name="xmi:type">uml:Property</xsl:attribute>
                        <xsl:attribute name="type"><xsl:value-of select="@type"/></xsl:attribute>
                    </xsl:element>
                </xsl:for-each>
            </xsl:element>
            
            <xsl:for-each select="//hml/types/type">
                <xsl:element name="packagedElement">
                    <xsl:attribute name="name"><xsl:value-of select="@name"/></xsl:attribute>
                    <xsl:attribute name="xmi:id"><xsl:value-of select="@id"/></xsl:attribute>
                    <xsl:choose>
                        <xsl:when test="@name = 'integer' or @name = 'boolean' or @name = 'default'">
                            <xsl:attribute name="xmi:type">uml:DataType</xsl:attribute>
                        </xsl:when>
                        <xsl:when test="count(./domain/value) > 0">
                            <xsl:attribute name="xmi:type">uml:Enumeration</xsl:attribute>
                            <xsl:for-each select="./domain/value">
                                
                            <xsl:element name="ownedAttribute">                         
                                <xsl:attribute name="name">
                                    <xsl:if test="@*[name(.)='is']">
                                        <xsl:value-of select="@is"/>
                                    </xsl:if>
                                    <xsl:if test="@*[name(.)='from']">
                                        <xsl:text>[</xsl:text>
                                        <xsl:value-of select="@from"/>
                                        <xsl:text>;</xsl:text>
                                        <xsl:value-of select="@to"/>
                                        <xsl:text>]</xsl:text>
                                    </xsl:if>
                                </xsl:attribute>
                                <xsl:attribute name="xmi:id"><xsl:value-of select="../../@id"/>_<xsl:value-of select="position()"/></xsl:attribute>
                                <xsl:attribute name="xmi:type">uml:Property</xsl:attribute>
                            </xsl:element>
                                
                            </xsl:for-each>                            
                        </xsl:when>
                        <xsl:otherwise>
                            <xsl:attribute name="xmi:type">uml:DataType</xsl:attribute>
                        </xsl:otherwise>
                    </xsl:choose>

                    <xsl:element name="generalization">                          
                        <xsl:attribute name="xmi:id">dtg_<xsl:value-of select="@name"/></xsl:attribute>
                        <xsl:attribute name="general"><xsl:value-of select="@base"/></xsl:attribute>
                        <xsl:attribute name="xmi:type">uml:Generalization</xsl:attribute>  
                    </xsl:element>   
                </xsl:element>
            </xsl:for-each>
            

        </xsl:element>
    </xsl:template>
    
</xsl:stylesheet>
